% AssetPathsAV.m
function [Paths1, Paths2]=AssetPathsAV(S0,mu,sigma,T,NSteps,NRepl)
dt = T/NSteps;
nudt = (mu-0.5*sigma^2)*dt;
sidt = sigma*sqrt(dt);
RandMat = randn(NRepl, NSteps);
Increments1 = nudt + sidt*RandMat;
Increments2 = nudt - sidt*RandMat;
LogPaths1 = cumsum([log(S0)*ones(NRepl,1) , Increments1] , 2);
LogPaths2 = cumsum([log(S0)*ones(NRepl,1) , Increments2] , 2);
Paths1 = exp(LogPaths1);
Paths2 = exp(LogPaths2);
